import java.util.*;
/**
 * InvalidList is a sequential list of bad upc's and error message.
 *
 * @author  J. Dalbey
 * @version 1
 */
public class InvalidList
{
    List<InvalidItem> list = new ArrayList<InvalidItem>();
    
    /**
     * Constructor for objects of class InvalidList
     */
    public InvalidList()
    {
    }
    /** Add a bad upc message */
    public void addBadUPC(UPC upc)
    {
      //    create an invalid item from upc and "invalid check digit"
      InvalidItem baditem = new InvalidItem(upc, "check digit doesn't match");
      list.add(baditem);
    }
    /** Add a missing upc message */
    public void addMissingUPC(UPC upc)
    {
      //    create an invalid item from upc and "invalid check digit"
      InvalidItem baditem = new InvalidItem(upc, "product doesn't exist");
      list.add(baditem);
    }
    /** Return a printable representation of this list */
    public String toString()
    {
        StringBuffer display = new StringBuffer();        
        //Display each item in invalidlist
        for (InvalidItem item : list)
        {
            display.append(item.upc + " ");
            display.append(item.message + "\n");
        }
        return display.toString();
    }

}
/** A wrapper for the bad upc and an error message */
class InvalidItem
{
    final UPC upc;
    final String message;
    public InvalidItem(UPC upc, String msg)
    {
        this.upc = upc;
        this.message = msg;
    }
}