
/**
 * ProductCount is a wrapper around a product and the number
 * of times it appeared.  ProductCount is immutable.
 *
 * @author  J. Dalbey
 * @version 1
 */
public class ProductCount
{
    public final Product item;
    private int itemCount;
    public ProductCount(Product newItem)
    {
        this.item = newItem;
        this.itemCount = 1;
    }
    /** Return an incremented version of this count */
    public ProductCount increment()
    {
        ProductCount newItem = new ProductCount(this.item);
        newItem.itemCount = this.itemCount + 1;
        return newItem;
    }
    /** Accessor to the count */
    public int getCount()
    {
        return itemCount;
    }
}