import java.util.*;
import java.io.*;
/**
 * ProductTable is a static table of available products.
 * 
 * @author  J. Dalbey
 * @version (a version number or a date)
 */
public class ProductTable
{
    private static Map<String,Product> productDB;

    /**
     * Constructor for objects of class ProductTable
     */
    public ProductTable()
    {
    }
    // Static Initializer Block http://docs.oracle.com/javase/tutorial/java/javaOO/initial.html
    static 
    {   
        productDB = new HashMap<String,Product>();
        try
        {
            //open the database file
            Scanner fileReader = new Scanner(new FileReader("productDB.txt"));
            
            String currentLine = null;
            String[] splitLine = null;
            String nameAndPrice = null;
            String delims = "[{\",]+";
            
            //FOR each line in input file LOOP
            while (fileReader.hasNextLine()) 
            {       
                // read an input line
                currentLine = fileReader.nextLine();
                // split into fields
                splitLine = currentLine.split(delims);
                nameAndPrice = splitLine[2] + "," + splitLine[4];
                UPC upc = new UPC(splitLine[1]);
                Product newItem = new Product(upc,splitLine[2],dollarsToInt(splitLine[4]));
                //Add line to product db
                productDB.put(splitLine[1], newItem);
            }     //END LOOP
        }
        catch (FileNotFoundException ex)
        {
            ex.printStackTrace();
            System.exit(1);
        }
    }
    // Parse string dollar amount into an int (cents)
    private static int dollarsToInt(String amount)
    {
        return Integer.parseInt(amount.replaceAll(",|\\.", ""));  
    }
    /** Lookup a given upc in the table */
    public static Product get(UPC target)
    {
        return productDB.get(target.upc);
    }
}
