import java.util.*;
/**
 * Purchases is the list of purchases obtained by scanning the UPC's.
 *
 * @author  J. Dalbey
 * @version (a version number or a date)
 */
public class Purchases
{

    Map<UPC,ProductCount> purchaseList;
    int totalPrice = 0;
    int totalItems = 0;
    
    /**
     * Constructor for objects of class Purchases
     */
    public Purchases()
    {
        purchaseList = new HashMap<UPC,ProductCount>();
    }
    /** Add one to the number of purchases for a given upc */
    public void incrementCount(UPC upc)
    {
        ProductCount pc = purchaseList.get(upc);        
        // If this is the first purchase of this product
        if (pc == null)
        {
            // create a new entry
            pc = new ProductCount(ProductTable.get(upc));
            purchaseList.put(upc, pc);
        }
        // update the count for a previously purchased product
        else
        {
            pc = pc.increment();
            purchaseList.put(upc, pc);
        }
    }
    /** Given a product, increment the total price with the price of this product.    */
    public void accumulateTotal(Product product)
    {
        totalPrice += product.price;
        totalItems++;
    }    
    /** Build a formatted sales receipt from the purchase data */
    public String assembleSalesReceipt()
    {
        StringBuffer salesReceipt = new StringBuffer();
        int subtotal = 0;
        // FOR each item in purchase list LOOP
        for (UPC upc : purchaseList.keySet())
        {
            ProductCount purchase = purchaseList.get(upc);
            //         compute the subtotal as itemcount * price.  
            subtotal = purchase.getCount() * purchase.item.price;
            //         format a line with product name, itemcount, subtotal
            String lineout = String.format("%-30s",purchase.item.productName) 
            +"\t("+ String.format("%3d",purchase.getCount()) +")\t"
            + String.format("%3.2f",subtotal/100.0)+"\n";
            //         append the line to the receipt
            salesReceipt.append(lineout);
        }        //     END LOOP
    
        //     Append the total price as the last line of the receipt
        salesReceipt.append(String.format("%30s","TOTAL") 
            + "\t("+ String.format("%3d",totalItems) +")\t"
            + String.format("%3.2f",totalPrice/100.0)+"\n");
        return salesReceipt.toString();    
    }       

}
