import java.util.*;
/**
 * A Register is a device that creates a sales receipt by
 * scanning UPC codes.
 * @author jdalbey
 * @version 1
 */
// Convert to OO - 3 hrs
// convert unit tests 15 min
// add some javadoc comments 20 min
// LOC: 138
public class Register
{
    Purchases purchases = new Purchases();
    // List of invalid items, in order of arrival.
    InvalidList invalidList;
    ProductTable products = new ProductTable();
    /**
     * Constructor for objects of class Register
     */
    public Register()
    {
    }
    /** Run the application */
    public void calculateSalesReceipt()
    {
        invalidList = new InvalidList();    
        processUPCs();
        System.out.println(purchases.assembleSalesReceipt());
        System.out.println(invalidList);
    }    
    /** Read and process the user input */
    public void processUPCs()
    {
        Scanner console = new Scanner(System.in);
        //WHILE more upc's exist LOOP
        while (console.hasNextLine())
        {
            //READ upc
            UPC rawUPC = new UPC(console.nextLine());
            // IF verified THEN
            if (rawUPC.verify())
            {
                UPC goodUPC = rawUPC;
                
                Product product = products.get(goodUPC);
                //IF product found in DB THEN
                if (product != null)
                {
                    purchases.incrementCount(goodUPC);
                    purchases.accumulateTotal(product);
                } //END IF    
                else
                {
                    invalidList.addMissingUPC(rawUPC);
                }
            }
            else
            {
                invalidList.addBadUPC(rawUPC);
            }
        } //END LOOP
    }

    /**
     *  Entry point for the application. 
     */
    public static void main(String[] args)
    {
        (new Register()).calculateSalesReceipt();
    }    
}
