
// Writing unit tests: Start 5:56 end 6:23
// start 7:44 end 7:57
// These no longer compile after converting app to OO,
// as there are class name conflicts
import java.util.*;
/**
 * The test class UpcReceiptCalcTest.
 *
 * @author jdalbey 
 * @version (a version number or a date)
 */
public class UpcReceiptCalcTest extends junit.framework.TestCase
{
    UpcReceiptCalc app;
    /**
     * Default constructor for test class UpcReceiptCalcTest
     */
    public UpcReceiptCalcTest()
    {
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    public void setUp()
    {
        app = new UpcReceiptCalc();
    }

    public void testVerifyUPC()
    {
        app.rawUPC = "088270221332";
        app.verifyUPC();
        assertEquals("088270221332",app.verifiedUPC);
    }
    public void testLookupProduct()
    {
        testReadDB();
        app.rawUPC = "088270221332";
        app.lookupProduct();
        assertEquals("088270221332",app.product.upc);
    }        
    public void testCountProduct()
    {
        testReadDB();
        app.purchaseList = new HashMap<String,ProductCount>();
        Product soda = new Product();
        soda.upc = "088270221332";
        soda.productName = "Soda";
        soda.price = 100;
        ProductCount sodacount = new ProductCount();
        sodacount.item = soda;
        sodacount.itemCount = 0;
        app.purchaseList.put(soda.upc,sodacount);
        app.verifiedUPC = "088270221332";
        app.countProduct();
        ProductCount result = app.purchaseList.get(app.verifiedUPC);
        assertEquals(1,result.itemCount);
    }
    public void testComputeTotal()
    {
        app.product = new Product();
        app.product.upc = "088270221332";
        app.product.productName = "Soda";
        app.product.price = 100;
        app.computeTotal();
        assertEquals(100,app.totalPrice);
    }
    public void assembleSalesReceipt()
    {
        app.purchaseList = new HashMap<String,ProductCount>();
        Product soda = new Product();
        soda.upc = "088270221332";
        soda.productName = "Soda";
        soda.price = 100;
        ProductCount sodacount = new ProductCount();
        sodacount.item = soda;
        sodacount.itemCount = 1;
        app.purchaseList.put(soda.upc,sodacount);
        app.assembleSalesReceipt();
        assertEquals("Soda   (1) 1.00 \n TOTAL 1.00 ", app.salesReceipt);
    }
    public void testReadDB()
    {
        app.productDB = new HashMap<String,Product>();
        app.readProductDB();
        Product item = app.productDB.get("088270221332");
        assertEquals("088270221332",item.upc);
    }
}
